(function($) {

	function Trace(){
		var FILE_PATH = 'traces_share/';
	    var intervalHandler = null;

	    this.init = function() {
	    	ap_showWaitMessage('generate_trace_main_container', 1);
	    	var date = new Date();
	    	var month = (+date.getMonth()+1>9)?date.getMonth()+1: '0'+(date.getMonth()+1);
	    	var fileName = 'trace_'+date.getFullYear()+'-'+month+'-'+date.getDate()+'_'+date.getHours()+'-'+date.getMinutes()+'.pcap'
	    	$('#generate_trace_trace_name').val(fileName);
            this._bindEvents();

            if (this._checkIsBackupsMounted()){
            	this.checkStatus();
            }else{
            	ap_showWaitMessage('generate_trace_main_container', 0);
            }
        }

	    this._bindEvents = function() {
            $('#generate_trace_start_btn').on('click', jQuery.proxy(this._onClickStartBtn, this));
            $('#generate_trace_stop_btn').on('click', jQuery.proxy(this._onClickStopBtn, this));
            $('#generate_trace_remove_file').on('click', jQuery.proxy(this._onClickRemoveBtn, this));
            $('#generate_trace_simple_radio, #generate_trace_advanced_radio').on('change', jQuery.proxy(this._onChangeRadioBtn, this));
        }


	    this._showError = function(message) {
            $('#generate_trace_information_fail').show().html(_t['generate_trace.on_failure'] + '<br />' + message);

            if(intervalHandler){
	    		clearInterval(intervalHandler);
	    		intervalHandler = null;
	    	}

            $('#generate_trace_information_processing').hide();
            $('#generate_trace_information_processing .size').text('');

            this._switchToStartButtons(true);
            this._unlockInputFields();
        },

        this.checkStatus = function() {
            var data = {
            		'action': 'status'
            }

            $.ajax({
                type: 'GET',
                url: "utilities/generate_trace/actions.php",
                data: data,
                dataType: 'json',
                success: jQuery.proxy(this._onAjaxRequestSuccess, this, data.action),
                error: jQuery.proxy(this._onAjaxRequestError, this, data.action)
            });
        }

        this.showDownloadLink = function(name, size){
        	$('.generate_trace_information').hide();
            $('#generate_trace_information_processing').hide();
            $('#generate_trace_information_processing .size').text('');
            if ($.trim(name) != '') {
            	var title = name;
            	if(size && size!=''){
            		title = title +' ('+this._reduceSize(size)+')';
            	}
                var download_link = "<a title=\"" + title + "\" href=\"" + FILE_PATH + name + "\" >" + title + "</a>";
                $('#generate_trace_download_trace_link').show();
                $('#generate_trace_link_field').html(download_link);
            }

            this.terminateGenerateTrace();
        }

        this.terminateGenerateTrace = function() {
	    	if(intervalHandler){
	    		clearInterval(intervalHandler);
	    		intervalHandler = null;
	    	}

	    	this._unlockInputFields();
	    	this._switchToStartButtons(true);
        }

        this._checkIsBackupsMounted = function(){
            if(is_backups_mounted == false) {
                setError('error', _t['strings.BackupsIsNotMounted']);
                this._lockInputFields();
                return false;
            } else {
                $('#undefined').hide('fast'); // Какого-то черта такой ID у error notification.
                $('#generate_trace_start_btn').prop('disabled', false);
                $('#generate_trace_stop_btn').prop('disabled', false);
                return true;
            }
        }

        this._hideDownloadLink = function(){
        	$('#generate_trace_link_field').empty();
	        $('#generate_trace_download_trace_link').hide();
        }

        this._unlockInputFields = function(){

        	if ($('#generate_trace_advanced_radio').is(':checked')) {
	    		$('#generate_trace_custom_tcpdump_input').prop('disabled', false);
	    		$('#generate_trace_ip_addr').prop('disabled', true);
	    	}else{
	    		$('#generate_trace_ip_addr').prop('disabled', false);
	    		$('#generate_trace_custom_tcpdump_input').prop('disabled', true);
	    	}

            $('#generate_trace_advanced_radio').prop('disabled', false);
            $('#generate_trace_simple_radio').prop('disabled', false);
            $('#generate_trace_trace_name').prop('disabled', false);
        }

        this._lockInputFields = function(){

        	$('#generate_trace_trace_name').prop('disabled', true);
        	$('#generate_trace_simple_radio').prop('disabled', true);
        	$('#generate_trace_ip_addr').prop('disabled', true);
        	$('#generate_trace_advanced_radio').prop('disabled', true);
        	$('#generate_trace_custom_tcpdump_input').prop('disabled', true);
        }

        this._switchToStartButtons = function(toStart){
        	if(toStart){
        		$('#generate_trace_stop_btn').prop('disabled', true);
	            $('#generate_trace_start_btn').prop('disabled', false);
        	}else{
        		$('#generate_trace_start_btn').prop('disabled', true);
	            $('#generate_trace_stop_btn').prop('disabled', false);
        	}
        }

        this._size = ['B', 'Kb', 'Mb', 'Gb', 'Tb'];
	    this._reduceSize = function(size){
    		var i=0;
    		while(size > 1000){
    			size = size/1024;
    			i++;
    		}
    		return size.toFixed(1)+''+this._size[i];
	    }

	    /************************
	     * start events
	     ************************/
	    this._onClickStartBtn = function(){
	    	if (intervalHandler != null) {
                clearInterval(intervalHandler);
            }

            var data = {
            		'traceName': $.trim($('#generate_trace_trace_name').val()),
                    'traceType': 1,
                    'command': '',
                    'action': 'start'
            }

            var options = {
			        rules: [ // rule, element_id, message
			            "required,generate_trace_trace_name," + gl_translation['rules.CannotBeEmpty'],
			            "reg_exp,generate_trace_trace_name,^[0-9a-z\\.\\-\\_]+$," + gl_translation['rules.enterValidValue']+" [0-9a-z.-]", //required,generate_trace_trace_name," + gl_translation['rules.CannotBeEmpty'],
			            "if:generate_trace_tcpdump=simple,valid_ipaddr,generate_trace_ip_addr," + gl_translation['rules.enterValidValue']+" IP",
			            "if:generate_trace_tcpdump=advanced,required,generate_trace_custom_tcpdump_input," + gl_translation['rules.CannotBeEmpty']
			        ],
			        customErrorHandler: function(f, errorInfo){
			        	return errorInfo.collect(function(info) {
							Element.insert(info[0],{'before': '<span class="err_span" style="color:#ff0000;">#{msg}<br></span>'.interpolate({msg: info[1]})});
						}).size() == 0;
			        }
            };

            if (!WMS.validate('generate_trace_main_container', options) ) {
		        return;
		    }

            if ($('#generate_trace_advanced_radio').is(':checked')) {
            	data.traceType = 2;
            	data.command = $.trim($('#generate_trace_custom_tcpdump_input').val());
            } else {
            	data.traceType = 1;
            	data.command = $.trim($('#generate_trace_ip_addr').val());
            }

            if (!$('#generate_trace_download_trace_link').is(":visible") ||
                    confirm(_t['generate_trace.confirm.start_generate'])) {

            	this._hideDownloadLink();

            	$('.error_message').html('');

            	this._switchToStartButtons(false);


	            $.ajax({
	                type: 'POST',
	                url: "utilities/generate_trace/actions.php",
	                data: data,
	                dataType: 'json',
	                success: jQuery.proxy(this._onAjaxRequestSuccess, this, data.action),
	                error: jQuery.proxy(this._onAjaxRequestError, this, data.action)
	            });
            }


	    }

	    this._onChangeRadioBtn = function(event){
	    	if($(event.target).val() == 'simple'){
	    		$('#generate_trace_ip_addr').prop('disabled', false);
	            $('#generate_trace_custom_tcpdump_input').prop('disabled', true);
	    	}else{
	    		$('#generate_trace_custom_tcpdump_input').prop('disabled', false);
	            $('#generate_trace_ip_addr').prop('disabled', true);
	    	}
	    }


	    this._onClickStopBtn = function(){
	    	if (intervalHandler != null) {
                clearInterval(intervalHandler);
                intervalHandler = null;
            }

	    	var data = {
                    'action': 'stop'
            }

	    	$.ajax({
                type: 'POST',
                url: "utilities/generate_trace/actions.php",
                data: data,
                dataType: 'json',
                success: jQuery.proxy(this._onAjaxRequestSuccess, this, data.action),
                error: jQuery.proxy(this._onAjaxRequestError, this, data.action)
            });
	    }

	    this._onClickRemoveBtn = function(){
	    	if (confirm(_t['generate_trace.confirm.delete_file'] + '')) {
	    		//send ajax request to remove file and clear div + hide it
	            ap_showWaitMessage('generate_trace_main_container', 1);
	            var data = {
	                    'action': 'remove'
	            }
	            $.ajax({
	                type: 'POST',
	                url: "utilities/generate_trace/actions.php",
	                data: data,
	                dataType: 'json',
	                success: jQuery.proxy(this._onAjaxRequestSuccess, this, data.action),
	                error: jQuery.proxy(this._onAjaxRequestError, this, data.action)
	            });
            }
	    }

	    this._onStartSuccess = function(){

	    	//_lockUnlockButtons
	    	this._switchToStartButtons(false);
            this._lockInputFields();

            //_showInformation
            $('.generate_trace_information').hide();
            $('#generate_trace_information_processing').show();

            //Checking by interval current status of tcpdump.
            intervalHandler = setInterval(jQuery.proxy(this.checkStatus, this), 5 * 1000);
	    }

	    this._onStatusSuccess = function(result){

	    	if(result.hasOwnProperty('traceSize')){
	    		$('#generate_trace_information_processing .size').text(this._reduceSize(result.traceSize));
	    	}

	    	if(result.hasOwnProperty('processIsRunning') && result.processIsRunning === true){
	    		$('#generate_trace_information_fail').show().html(' ');

                if (result.traceType === 1) {
	                $('#generate_trace_ip_addr').val(result.traceParam);
	                $('#generate_trace_simple_radio').attr('checked', true);
	            } else {
	                $('#generate_trace_custom_tcpdump_input').val(result.traceParam);
	                $('#generate_trace_advanced_radio').attr('checked', true);
	            }

	            $('#generate_trace_trace_name').val(result.traceName);

	            if(intervalHandler == null){
	            	this._onStartSuccess();
	            }
	    	}else{
	    		this.showDownloadLink(result.traceName, result.traceSize);
	    	}
	    }

	    this._onStopSuccess = function(result){
	    	if(result.hasOwnProperty('processIsRunning') && result.processIsRunning === true){

	    	}else{
	    		this.showDownloadLink(result.traceName, result.traceSize);
	    	}
	    }

	    this._onRemoveSuccess = function(result){
	    	this._hideDownloadLink();
	    }

	    this._onAjaxRequestSuccess = function(type, response, textStatus, jqXHR){
	    	ap_showWaitMessage('generate_trace_main_container', 0);
	    	if(response.hasOwnProperty('type')){
	    		if(response.type == 'result' && response.result != null){
	    			if(type == 'start'){
	    				this._onStartSuccess();
	    			}else if(type == 'status'){
	    				this._onStatusSuccess(response.result);
	    			}else if(type == 'stop'){
	    				this._onStopSuccess(response.result);
	    			}else if(type == 'remove'){
	    				this._onRemoveSuccess(response.result);
	    			}
                    return true;
		    	}else if(response.hasOwnProperty('reason')){
		    		this._onAjaxRequestError(type, jqXHR, textStatus, response.reason)
		    	}else{
		    		this._onAjaxRequestError(type, jqXHR, textStatus, 'Unknown error')
		    	}
	    	}else{
	    		this._onAjaxRequestError(type, jqXHR, textStatus, 'Unknown error')
	    	}
	    }

	    this._onAjaxRequestError = function(type, jqXHR, textStatus, errorThrown){
	    	ap_showWaitMessage('generate_trace_main_container', 0);
	    	this._showError(errorThrown);
	    }
	    /************************
	     * end events
	     ************************/
	}

	generateTrace = Trace;
})(jQuery);